<script lang="ts">
import Vue from 'vue';
import FeatureList from './feature-list.vue';
import FeaturedAddOnsCardTier from './featured-add-ons-card-tier.vue';
import { toKebabCaseMixin } from '../../mixins';

export default Vue.extend({
  components: {
    FeatureList,
    FeaturedAddOnsCardTier,
  },
  mixins: [toKebabCaseMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
    isSelfManaged: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
});
</script>

<template>
  <div id="addons" class="addons__container">
    <SlpTypography variant="heading2-bold" tag="h2"
      >{{ data.heading }}
      <a class="header-anchor" :href="`#addons`" aria-hidden="true"
        ><svg
          width="16"
          height="16"
          viewBox="0 0 16 16"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M12.2426 3.75736C11.4615 2.97631 10.1952 2.97631 9.41416 3.75736L7.99995 5.17157C7.60942 5.56209 6.97626 5.56209 6.58573 5.17157C6.19521 4.78105 6.19521 4.14788 6.58573 3.75736L7.99995 2.34314C9.56205 0.781046 12.0947 0.781046 13.6568 2.34314C15.2189 3.90524 15.2189 6.4379 13.6568 8L12.2426 9.41421C11.8521 9.80473 11.2189 9.80473 10.8284 9.41421C10.4379 9.02369 10.4379 8.39052 10.8284 8L12.2426 6.58578C13.0236 5.80473 13.0236 4.5384 12.2426 3.75736Z"
            fill="#333333"
          ></path>
          <path
            d="M10.5355 5.4645C10.926 5.85502 10.926 6.48819 10.5355 6.87871L6.87863 10.5356C6.4881 10.9261 5.85494 10.9261 5.46441 10.5356C5.07389 10.145 5.07389 9.51188 5.46441 9.12135L9.12127 5.4645C9.51179 5.07397 10.145 5.07397 10.5355 5.4645Z"
            fill="#333333"
          ></path>
          <path
            d="M3.75742 9.41422C2.97637 10.1953 2.97637 11.4616 3.75742 12.2426C4.53847 13.0237 5.8048 13.0237 6.58584 12.2426L8.00006 10.8284C8.39058 10.4379 9.02375 10.4379 9.41427 10.8284C9.8048 11.219 9.8048 11.8521 9.41427 12.2426L8.00006 13.6569C6.43796 15.219 3.9053 15.219 2.3432 13.6569C0.781107 12.0948 0.781107 9.56211 2.3432 8.00001L3.75742 6.5858C4.14794 6.19527 4.78111 6.19527 5.17163 6.5858C5.56216 6.97632 5.56215 7.60948 5.17163 8.00001L3.75742 9.41422Z"
            fill="#333333"
          ></path>
        </svg>
      </a>
    </SlpTypography>
    <SlpTypography variant="heading4" tag="h3" class="addons__subtitle"
      >{{ data.text }}
    </SlpTypography>
    <div
      class="addons__card_container addons__row"
      :class="{ 'addons__card_container--is-sm': isSelfManaged }"
    >
      <div
        v-for="card in data.cards"
        :key="card.title"
        size="lg"
        class="addons__col"
      >
        <FeaturedAddOnsCardTier
          v-if="card.featured && card.variant == 'tier'"
          :data="card"
          :is-self-managed="isSelfManaged"
        />
        <a
          v-else-if="!card.featured"
          class="addons__card"
          :href="card.link.url"
          :data-ga-name="card.link.data_ga_name"
          :data-ga-location="card.link.data_ga_location"
        >
          <div class="addons__card-brace">
            <SlpPillButton v-if="card.pill" type="true" class="slp-mb-16">
              {{ card.pill }}
            </SlpPillButton>
            <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-16">
              {{ card.title }}
            </SlpTypography>
            <SlpTypography
              :id="card.id || anchorID(card.heading)"
              variant="heading4"
              class="addons__card_heading"
              tag="h3"
              >{{ card.heading
              }}<a
                class="header-anchor"
                :href="`#${card.id}` || `#${anchorID(card.heading)}`"
                aria-hidden="true"
                ><svg
                  width="16"
                  height="16"
                  viewBox="0 0 16 16"
                  fill="none"
                  xmlns="http://www.w3.org/2000/svg"
                >
                  <path
                    d="M12.2426 3.75736C11.4615 2.97631 10.1952 2.97631 9.41416 3.75736L7.99995 5.17157C7.60942 5.56209 6.97626 5.56209 6.58573 5.17157C6.19521 4.78105 6.19521 4.14788 6.58573 3.75736L7.99995 2.34314C9.56205 0.781046 12.0947 0.781046 13.6568 2.34314C15.2189 3.90524 15.2189 6.4379 13.6568 8L12.2426 9.41421C11.8521 9.80473 11.2189 9.80473 10.8284 9.41421C10.4379 9.02369 10.4379 8.39052 10.8284 8L12.2426 6.58578C13.0236 5.80473 13.0236 4.5384 12.2426 3.75736Z"
                    fill="#333333"
                  ></path>
                  <path
                    d="M10.5355 5.4645C10.926 5.85502 10.926 6.48819 10.5355 6.87871L6.87863 10.5356C6.4881 10.9261 5.85494 10.9261 5.46441 10.5356C5.07389 10.145 5.07389 9.51188 5.46441 9.12135L9.12127 5.4645C9.51179 5.07397 10.145 5.07397 10.5355 5.4645Z"
                    fill="#333333"
                  ></path>
                  <path
                    d="M3.75742 9.41422C2.97637 10.1953 2.97637 11.4616 3.75742 12.2426C4.53847 13.0237 5.8048 13.0237 6.58584 12.2426L8.00006 10.8284C8.39058 10.4379 9.02375 10.4379 9.41427 10.8284C9.8048 11.219 9.8048 11.8521 9.41427 12.2426L8.00006 13.6569C6.43796 15.219 3.9053 15.219 2.3432 13.6569C0.781107 12.0948 0.781107 9.56211 2.3432 8.00001L3.75742 6.5858C4.14794 6.19527 4.78111 6.19527 5.17163 6.5858C5.56216 6.97632 5.56215 7.60948 5.17163 8.00001L3.75742 9.41422Z"
                    fill="#333333"
                  ></path>
                </svg>
              </a>
            </SlpTypography>
            <div>
              <div class="addons__card_price">
                <SlpTypography variant="heading1-bold" tag="h4"
                  >${{ card.price }}
                </SlpTypography>
                <div class="details">
                  <SlpTypography variant="body2" tag="p"
                    >{{ card.price_info }}
                  </SlpTypography>
                  <SlpTypography variant="body2" tag="p"
                    >{{ card.description }}
                  </SlpTypography>
                </div>
              </div>
            </div>
            <div v-if="card.features?.list" class="slp-mb-24">
              <FeatureList :data="card.features"></FeatureList>
            </div>
            <div
              v-if="card.card_note"
              class="footnotes"
              v-html="$md.render(card.card_note)"
            ></div>
            <SlpTypography variant="body2-bold" tag="span" class="addons__link">
              <span> {{ card.link.text }}</span>
              <SlpIcon
                name="chevron-lg-right"
                variant="product"
                slp-color="primary-200"
                alt="Chevron Right Icon"
              />
            </SlpTypography>
          </div>
        </a>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.italicize {
  font-style: italic;
}

.addons {
  &__container {
    background: $color-surface-800;
    border-radius: $border-radius-24;
    margin-bottom: $spacing-96;
    padding: $spacing-32 $spacing-16;

    @media (min-width: $breakpoint-lg) {
      padding: $spacing-96 $spacing-64;
    }

    :deep {
      .pricing-feature-list-container .item {
        margin-bottom: $spacing-16;
        margin-top: 0;
      }
    }
  }

  &__card_container {
    width: 100%;

    &.addons__card_container--is-sm {
      .addons__col {
        &:nth-child(3) {
          grid-row-end: span 2;
          grid-column-end: span 2;
        }

        &:nth-child(4),
        &:nth-child(5) {
          display: none;
        }
      }
    }
  }

  &__subtitle {
    @media (min-width: $breakpoint-lg) {
      width: 60%;
    }

    margin-bottom: 40px;
  }

  &__card-brace {
    display: flex;
    flex-direction: column;
    height: 100%;
  }

  &__card {
    border-radius: 12px;
    display: block;
    padding: $spacing-24;
    background-color: white;
    // margin-bottom: $spacing-24;
    transition: all 0.3s ease-in;
    height: 100%;
    color: $color-text-300;

    &:hover {
      box-shadow: 0 24px 50px -16px #d1d0d3;
    }

    @media (min-width: $breakpoint-lg) {
      width: 100%;
      // width: 440px;
      padding: 40px $spacing-48;
    }

    &_heading {
      margin-bottom: 40px;
      color: $color-text-300;
    }

    &_price {
      display: flex;
      flex-direction: row;
      align-items: center;
      margin-bottom: $spacing-24;

      h1 {
        color: $color-text-300;
      }

      .details {
        margin-left: $spacing-24;
        max-width: inherit;
        word-break: break-word;
        color: $color-text-link-100;

        p {
          font-weight: bold;
        }
      }
    }

    :deep {
      .slp-pill-btn {
        cursor: default;
        padding: 4px 12px;

        .slp-icon {
          display: none;
        }
      }

      .list {
        margin-bottom: 0;
      }
    }
  }

  &__link {
    color: black;
    display: block;
    // padding-right: 20px;
    position: relative;
    padding: $spacing-16 0;
    margin: auto 0 0 0;

    .slp-icon {
      width: 18px;
      height: 20px;
      display: inline-flex;
      position: relative;

      :deep div {
        position: absolute;
        top: 2px;
        left: 0;
      }
    }

    &--hide-on-mobile {
      display: none;

      @media (min-width: $breakpoint-md) {
        display: block;
      }
    }

    &--hide-on-desktop {
      display: block;

      @media (min-width: $breakpoint-md) {
        display: none;
      }
    }
  }

  &__col {
    &:nth-child(3) {
      grid-row-end: span 2;
    }
  }

  &__row {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 32px;

    @media (min-width: $breakpoint-md) {
      grid-template-columns: 1fr 1fr;
      grid-gap: 32px;
    }
  }
}
.footnotes {
  color: $color-surface-300;
  font-size: 14px;
  line-height: 22px;
  margin-top: 16px;
  color: #74717a;
  font-style: italic;
}
</style>
